<template>
  <div class="boardpage">

    <span class='boardpage-head'>{{board.name}}</span>

    <ModalBoardEdit @updateName="updateBoardName" :board="board"/>
    <ModalBoardDelete :board="board"/>
    <ModalListAdd :board="board"/>
    <br/><br/><br/>

    <ul id="boards-list" style=" list-style-type:none;">
      <b-card-group deck style="flex-flow: row nowrap;">

        <li v-for="list in board.lists" :key="list._id">
          <b-card
            style="width: 270px; min-height: 300px; display: inline-block;"
            bg-variant="light"
          >

            <template #header>
              <h6 class="mb-0">{{list.name}}</h6>
            </template>

            <!-- <b-button variant="info" class='ml-2' size="sm"><font-awesome-icon icon="pen" /></b-button> -->
            <ModalListEdit :list="list"/>
            <ModalListDelete :list="list"/>
            <ModalCardAdd :list="list"/>

            <br/><br/>

            <ul id="cards" style="list-style-type:none; margin-left: 0px; padding-left:0px;">
                <li v-for="card in list.cards" :key="card._id">
                  <b-card
                    style="width:96%; margin-left: 2%; padding-left:0px; margin-top:10px"
                  >
                    <b-card-text>
                      <span class='card-title'>{{card.title}}</span>
                      <!-- <b-button variant="outline-info" class='ml-3' size="sm"><font-awesome-icon icon="pen" /></b-button> -->
                      <ModalCardEdit :card="card" :board="board" :list="list"/>
                    </b-card-text>
                    
                    <b-card-text class='card-text'>
                      {{card.description}}
                    </b-card-text>


                  </b-card>
                </li>
            </ul>
            
          </b-card>
              
        </li>       
      </b-card-group>

    </ul>

  </div>
</template>

<script>

import ModalBoardEdit from './modals-components/ModalBoardEdit.vue';
import ModalBoardDelete from './modals-components/ModalBoardDelete.vue';
import ModalListAdd from './modals-components/ModalListAdd.vue';
import ModalCardAdd from './modals-components/ModalCardAdd.vue';
import ModalListDelete from './modals-components/ModalListDelete.vue';
import ModalListEdit from './modals-components/ModalListEdit.vue';
import ModalCardEdit from './modals-components/ModalCardEdit.vue';

import axios from 'axios';

export default {
  name: 'boardpage',
  props: [],
  components:{
    ModalBoardEdit, ModalBoardDelete, ModalListAdd, 
    ModalCardAdd, ModalListDelete, ModalListEdit,
    ModalCardEdit
  },
  data(){
    return {
      id: this.$route.params.id,
      board: null
    }
  },
  methods:{
    showModal() {
      this.$refs['m-card-add-' + this.list._id].show()
    },
    updateBoardName(boardName){
      this.board.name = boardName
    }
  },
  mounted () {

    axios.get(`${process.env.VUE_APP_URL}/boards/${this.id}`)
      .then(response => {
          this.board = response.data
      })
      .catch(error => alert("error " + error))
  }
}
</script>


<style scoped>
.boardpage{
  margin-top: 5%;
}

.boardpage-head{
  font-size: 30px;
  margin-left: 50px;
}

.card-title{
  font-size: 15px;
  font-weight: bold;
}

.card-text {
  font-size:14px;
  overflow: hidden;
  text-overflow: ellipsis;
  display: -webkit-box;
  -webkit-line-clamp: 3; /* number of lines to show */
  -webkit-box-orient: vertical;
}

#card{
  text-align: left;
  margin-left:0%
}
</style>
